#include <stdio.h>
#include "define.h"

FILE        *fp;

RestoreLast2State()
{
  TTime1 = TTime12; TTime2 = TTime22;
  Tpx = Tpx2; Tpy = Tpy2; Tps = Tps2;
  Tnx = Tnx2; Tny = Tny2; Tns = Tns2;
  Tnx2 = Tnx3; Tny2 = Tny3;
}

SaveLastState(x0,y0,x,y,n)
int x0,y0,x,y,n;
{
  if (matta != 2) matta++;

  Tnx3 = Tnx2; Tny3 = Tny2;
  TTime12 = TTime1; TTime22 = TTime2;
  Tpx2 = Tpx; Tpy2 = Tpy; Tps2 = Tps;
  Tnx2 = Tnx; Tny2 = Tny; Tns2 = Tns;

  Tpx = x0; Tpy = y0;
  Tnx =  x; Tny =  y; Tns = Board[y][x];
  if (n == TRUE) Tps = 0;
  else Tps = Board[y0][x0];
  TTime1 = Time1; TTime2 = Time2;
}

RestoreSaveState()
{
  int i=0,j,player,temp;
  while (FILENAME[i] != '\0') 
    if (FILENAME[i] == '.' && FILENAME[i+1] == 'x' && FILENAME[i+2] == '2') 
      break;
    else i++;
  if (FILENAME[i] == '\0') strcat (FILENAME,".x2shogi");
  
  if ((fp = fopen(FILENAME, "r")) == NULL) {
    printf("I can't read %s.\n",FILENAME);
    exit(1);
  }
  fscanf(fp, "%d ", &player);
  if (player != 20520 && player != SAVEDATA03 && player != SAVEDATA) {
    printf("%s is not a x2shogi's state-file.\n",FILENAME);
    exit(1);
  }
  for (i=0;i<9;i++) 
    for (j=0;j<9;j++) {
      fscanf(fp, "%d ", &Board[i][j]);
      if (player != SAVEDATA03) fscanf(fp, "%d ", &temp);
    }
  for (i=0;i<40;i++) {
    if (player != SAVEDATA03) 
      fscanf(fp, "%d %d %d %d ", 
	  &Mochigoma1[i], &temp, &Mochigoma2[i], &temp);
    else fscanf(fp, "%d %d ", &Mochigoma1[i], &Mochigoma2[i]);
  }
  i = 0;
  while (Mochigoma1[i] != 0) i++;
  m1 = i;
  i = 0;
  while (Mochigoma2[i] != 0) i++;
  m2 = i;
  if (player != SAVEDATA03) {
    fscanf(fp,"%d %d %d %d %d %d", 
	   &temp, &temp, &Time1, &Time2, &TimeMode1, &player);
    TimeMode2 = TimeMode1;
  } else {
    fscanf(fp,"%d %d %d %d %d", 
	   &Time1, &Time2, &TimeMode1, &TimeMode2, &player);
    fscanf(fp,"%d %d", &Tnx, &Tny);
    if (player == 1) player = 2; else player = 1;
  }
  fclose(fp);
  printf("Now restoring the last state.\n");
  return player;
}

SaveState(n)
int n;
{
  int i,j;
  char ans[10],fname[30];

  PrintMessage(6);
  PrintMessage2(6);
  printf("Input a name of your state-file, or cancel.              -> ");
  Scanf(fname);
  if (strcmp(fname,"cancel") == 0) {
    printf("Not be saved.\n");
    return;
  }
  strcat(fname,".x2shogi");
  if ((fp = fopen(fname, "r")) != NULL) {
    printf("Can I overwrite this file?                 (y or others) -> ");
    Scanf(ans);
    if (strcmp("y",ans) != 0) {
      printf("Not be saved.\n");
      return;
    }
  }
  if ((fp = fopen(fname, "w")) == NULL) {
    printf("I can't write in this file.\n");
    return;
  }
  fprintf(fp, "%d\n",SAVEDATA03);
  for (i=0;i<9;i++) {
    for (j=0;j<9;j++) fprintf(fp, "%3d  ", Board[i][j]);
    fprintf(fp, "\n");  
  }
  fprintf(fp, "\n");  
  for (i=0;i<40;i++) fprintf(fp, "%3d  %3d\n", Mochigoma1[i], Mochigoma2[i]);
  if (n == 1) n = 2; else n = 1;
  fprintf(fp,"\n%7d%7d %5d%5d\n", Time1, Time2, TimeMode1, TimeMode2);
  fprintf(fp,"%3d       %3d%3d\n", n, Tnx, Tny);
  fclose(fp);
  printf("%s file is keeping this state.\n",fname);
  unlink("backup.x2shogi");
  exit(1);
}

MakeBackup(n)
int n;
{
  int i,j;
  char fname[30];
  strcpy(fname,"backup.x2shogi");
  if ((fp = fopen(fname, "w")) == NULL) {
    printf("I can't write a backup file in this directory.\n");
    return;
  }
  fprintf(fp, "%d\n",SAVEDATA03);
  for (i=0;i<9;i++) {
    for (j=0;j<9;j++) fprintf(fp, "%3d  ", Board[i][j]);
    fprintf(fp, "\n");  
  }
  fprintf(fp, "\n");  
  for (i=0;i<40;i++) fprintf(fp, "%3d  %3d\n", Mochigoma1[i], Mochigoma2[i]);
  if (n == 1) n = 2; else n = 1;
  fprintf(fp,"\n%7d%7d %5d%5d\n", Time1, Time2, TimeMode1, TimeMode2);
  fprintf(fp,"%3d       %3d%3d\n", n, Tnx, Tny);
  fclose(fp);
}

Scanf(string)
char *string;
{
  int c,i=0;
  while ((c = getchar()) != '\n')
    string[i++] = c;
  string[i] = '\0';
}
