/*
 * 2way SHOGI (x2shogi) - SHOGI in a two-way process for X-window
 *
 *   Copyright (C)  1993  Yusaku Okamura
 *
 *  Author: Yusaku Okamura
 *  Design: Masaki Endo
 *
 * Permission to use, copy, modify and distrubute without charge this software,
 * documentation, images, etc. is granted, provided that this comment and
 * the author's name is retained. The author assumes no responsibility
 * for lost sleep as a consequence of use of this software.
 *
 *  Send any comments, bug reports, etc. to: t20520@ee.t.u-tokyo.ac.jp
 */

#include <signal.h>
#include "main.h"

static int SBoard[9][9] = 
               {GYO2,KEI2,GIN2,KIN2,OO2,KIN2,GIN2,KEI2,GYO2,
                0,HISHA2,0,0,0,0,0,KAKU2,0,
                FU2,FU2,FU2,FU2,FU2,FU2,FU2,FU2,FU2,
                0,0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,0,
                FU1,FU1,FU1,FU1,FU1,FU1,FU1,FU1,FU1,
                0,KAKU1,0,0,0,0,0,HISHA1,0,
                GYO1,KEI1,GIN1,KIN1,OO1,KIN1,GIN1,KEI1,GYO1};

int m1=0,m2=0,Board[9][9],BoardW[9][9],
  Mochigoma1[40],Mochigoma1W[40],Mochigoma2[40],Mochigoma2W[40],
  matta,BELL,IFIRST,TimeAfter1,TimeAfter2,
  Time1,Time2,TimeMode1,TimeMode2,NOOHTE,NONAME,NOMATTA,NOTSUMI,
  Tpx,Tpy,Tps,Tnx,Tny,Tns,TTime1,TTime2,
  Tpx2,Tpy2,Tps2,Tnx2,Tny2,Tns2,TTime12,TTime22,
  Mt,koma,Tnx3,Tny3;

char DISPLAY[30],TIME[10],TIME1[10],TIME2[10],TIME3[10],FILENAME[30];

Display *d,*d2;
Window  win[46], win2[46], iconwin, iconwin2;
GC          gc, gcb, gc2, gcb2;
XGCValues   gcv, gcvb, gcv2, gcvb2;
XFontStruct *font,*font2;
unsigned long fg, bg, dd, fg2, bg2, dd2;
XEvent      event,event2;
Pixmap      pixmap;
XWMHints    *wmhints,*wmhints2;

int TimeCount1();
int TimeCount2();

main(argc, argv)
     int argc;

char **argv;
{ 
 int phase,phase2,koma2,func,m,i,j,mtcount;
 BELL = TRUE,IFIRST = 1,NOOHTE = FALSE,
 NONAME = FALSE,NOMATTA = FALSE,NOTSUMI = FALSE,
 Tnx = 99; Tny = 99;
 m1 = m2 = 0, matta = 0;
 koma = 99;

 for (j=0;j<9;j++)
   for (i=0;i<9;i++)
     Board[j][i]  = SBoard[j][i];

 if (GetArgs(argc, argv) == FALSE) PrintArg();

 PrintTitle();
 if (FILENAME[0] != '\0') IFIRST = RestoreSaveState();
 else AskTime();

 Open_Display();
 Open_Display2();
 Create_Koma();
 TimeAfter1 = TimeMode1;
 TimeAfter2 = TimeMode2;

 phase2 = FIRST;

 if (IFIRST == 2) {
   XNextEvent(d, &event);
   switch(event.type){
   case Expose:
     DrawLine();
   }
   ExposePrintMessage(1);
   ExposePrintTime1();
   goto Player2;
 }

 XNextEvent(d2, &event2);
 switch(event2.type){
 case Expose:
   DrawLine2();
 }

 ExposePrintMessage2(1);
 ExposePrintTime2();
 Player1:
 /*PrintBoard(Board);*/
 MakeBackup(1);
 if (NOTSUMI == FALSE)
   if (CheckTsumi(1,Board)) Win(6);
 if (BELL) XBell(d, 100); 
 if (NOOHTE == FALSE && BELL)
   if (CheckOhte(1,Board)) XBell(d, 100);
 if (Time1 == 0) XFillRectangle(d,win[0],gcb,FILLYOUx,FILLYOUy,70,26);
 TimeAfter1 = TimeMode1;
 mtcount = 2;
 alarm(1);
 signal(SIGALRM, TimeCount1);
 phase = PICK;
 koma2 = FIRST;
 while(1){
   int x,y,x0,y0;
   XNextEvent(d, &event);
   switch(event.type){
     case Expose:
       DrawLine();
       WindowPick(koma);
       if (phase2 == FIRST || phase != PICK) ExposePrintMessage(0);
       else if (phase2 == MATTA) ExposePrintMessage(8);
       else ExposePrintMessage(4);
       ExposePrintTime1();
       break;
     case EnterNotify:
       XSetWindowBorderWidth(d, event.xcrossing.window, 1);
       if (event.xcrossing.window == win[43]) func = 43;
       else func = 44;
       break;
     case LeaveNotify:
       XSetWindowBorderWidth(d, event.xcrossing.window, 0);
       break;
     case ButtonPress:
       if (event.xany.window == win[43] || event.xany.window == win[44] ||
	   event.xany.window == win[45]) {
	 XSetWindowBorderWidth(d, win[func], 0);
	 if (event.xany.window == win[45]) {
	   signal(SIGALRM, SIG_IGN);
	   if (BELL) XBell(d2, 100); 
	   SaveState(1);
	   alarm(1);
	   signal(SIGALRM, TimeCount1);
	   XFillRectangle(d,win[0],gcb,FILLMESx,FILLMESy,450,26);
	   XFillRectangle(d2,win2[0],gcb2,FILLMESx,FILLMESy,450,26);
	 } else if (event.xany.window == win[43]) {
/* matta function */
	   if (matta == 2 && mtcount != 0) {
	     mtcount--;
	     if (AskMatta(1,phase2) == TRUE) {
	       PrintMessage2(8);
	       signal(SIGALRM, SIG_IGN);	       
	       WindowBorderErase(koma);
	       RestoreLastState(1);
	       RestoreLastState(2);
	       if (Tnx != 99) koma = BoardW[Tny][Tnx];
	       phase2 = MATTA;
	       XFillRectangle(d,win[0],gcb,FILLMESx,FILLMESy,450,26);
 	       XFillRectangle(d2,win2[0],gcb2,FILLYOUx,FILLYOUy,70,26);
	       XFillRectangle(d2,win2[0],gcb2,FILLHISx,FILLHISy,70,26);
	       XFillRectangle(d,win[0],gcb,FILLYOUx,FILLYOUy,70,26);
	       XFillRectangle(d,win[0],gcb,FILLHISx,FILLHISy,70,26);
	       PrintMessage2(1);
	       goto Player1;
	     } else {
	       phase2 = SORRY;
	       PrintMessage2(1);
	       PrintMessage(4);
	     }
	   }
	 } else {
	   if (AskNage(1) == TRUE) {
	     signal(SIGALRM, SIG_IGN);
	     Win(3);
	   }
	 }
       } 
    /* get Koma if (phase == PICK) */
       if (phase == PICK){
         x0 = XtoB(event.xbutton.x);
         y0 = YtoB(event.xbutton.y);
	 m = BtoM(event.xbutton.x,event.xbutton.y);
         if (CheckInM(event.xbutton.x,event.xbutton.y)){
	   if (koma2 == FIRST) {
	     WindowBorderErase(koma);
	     koma2 = SORRY;
	   }
	   PrintMessage(0);
	   koma = Mochigoma1W[BtoM(event.xbutton.x,event.xbutton.y)];
           WindowPick(koma);
           phase = MPUT;
         } else if (CheckInB(x0,y0) && CheckFriend(x0,y0)){
	   if (koma2 == FIRST) {
	     WindowBorderErase(koma);/* This command erases enemy's trail.*/
	     koma2 = SORRY;
	   }
	   PrintMessage(0);
	   koma = BoardW[y0][x0];
           WindowPick(koma);
           phase = PUT;
         }
         break;
       }
    /* put Koma if (phase == PUT) */
       else if (phase == PUT){
         x = XtoB(event.xbutton.x);
         y = YtoB(event.xbutton.y);
         if (CheckInB(x,y) && (CheckFriend(x,y) == FALSE) &&
           CheckMovePossible(x0,y0,x,y) && (Button3 != event.xbutton.button)) {
	   SaveLastState(x0,y0,x,y,FALSE);
	   i = koma;
           WindowBorderErase(koma);
           MoveKoma(x0,y0,x,y);
	   koma = i;
           WindowPick(koma);
	   signal(SIGALRM, SIG_IGN);
	   PrintMessage2(0);
	   PrintMessage(1);
	   phase2 = FIRST;
           goto Player2;
         }
         phase = PICK;
	 phase2 = SORRY;
         PrintMessage(4);
	 WindowBorderErase(koma);
         break;
       }
    /* put Mochigoma (phase == MPUT) */
       else {
         x = XtoB(event.xbutton.x);
         y = YtoB(event.xbutton.y);
         if (CheckInB(x,y) && (Board[y][x] == 0) && (NiFU(m,x,y) == FALSE) &&
            (Button3 != event.xbutton.button) &&
            (Uchifuzume(1,m,x,y) == FALSE)) {
           SaveLastState(x0,y0,x,y,TRUE);
	   i = koma;
	   WindowBorderErase(koma);
           MoveMochigoma(m,x,y);
	   koma = i;
	   WindowPick(koma);
	   signal(SIGALRM, SIG_IGN);
           PrintMessage2(0);
           PrintMessage(1);
	   phase2 = FIRST;
           goto Player2;
         }
         phase = PICK;
	 phase2 = SORRY;
         PrintMessage(4);
	 WindowBorderErase(koma);
         break;
       }
   }
 }

 Player2:
 /*PrintBoard(Board);*/
 MakeBackup(2);
 if (NOTSUMI == FALSE)
   if (CheckTsumi(2,Board)) Win(5);
 if (BELL) XBell(d2, 100);
 if (NOOHTE == FALSE && BELL)
   if (CheckOhte(2,Board)) XBell(d2, 100);
 if (Time2 == 0) XFillRectangle(d2,win2[0],gcb2,FILLYOUx,FILLYOUy,70,26);
 TimeAfter2 = TimeMode2;
 mtcount = 2;
 alarm(1);
 signal(SIGALRM, TimeCount2);
 phase = PICK;
 koma2 = FIRST;
 while(1){
   int x,y,x0,y0;
   XNextEvent(d2, &event2);
   switch(event2.type){
     case Expose:
       DrawLine2();
       WindowPick(koma);
       if (phase2 == FIRST || phase != PICK) ExposePrintMessage2(0);
       else if (phase2 == MATTA) ExposePrintMessage2(8);
       else ExposePrintMessage2(4);
       ExposePrintTime2();
       break;
     case EnterNotify:
       XSetWindowBorderWidth(d2, event2.xcrossing.window, 1);
       if (event2.xcrossing.window == win2[43]) func = 43;
       else func = 44;
       break;
     case LeaveNotify:
       XSetWindowBorderWidth(d2, event2.xcrossing.window, 0);
       break;
     case ButtonPress:
       if (event2.xany.window==win2[43] || event2.xany.window==win2[44] ||
	   event2.xany.window==win2[45]) {
	 XSetWindowBorderWidth(d2, win2[func], 0);
         if (event2.xany.window == win2[45]) {
	   signal(SIGALRM, SIG_IGN);
	   if (BELL) XBell(d2, 100); 
           SaveState(2);
	   alarm(1);
	   signal(SIGALRM, TimeCount2);
	   XFillRectangle(d,win[0],gcb,FILLMESx,FILLMESy,450,26);
	   XFillRectangle(d2,win2[0],gcb2,FILLMESx,FILLMESy,450,26);
         } else if (event2.xany.window == win2[43]) {
/* matta function */
	   if (matta == 2 && mtcount != 0) {
	     mtcount--;
	     if (AskMatta(2,phase2) == TRUE) {
	       PrintMessage(8);
	       signal(SIGALRM, SIG_IGN);
	       WindowBorderErase(koma);
	       RestoreLastState(2);
	       RestoreLastState(1);
	       if (Tnx != 99) koma = BoardW[Tny][Tnx];
	       phase2 = MATTA;
	       XFillRectangle(d2,win2[0],gcb2,FILLMESx,FILLMESy,450,26);
 	       XFillRectangle(d2,win2[0],gcb2,FILLYOUx,FILLYOUy,70,26);
	       XFillRectangle(d2,win2[0],gcb2,FILLHISx,FILLHISy,70,26);
	       XFillRectangle(d,win[0],gcb,FILLYOUx,FILLYOUy,70,26);
	       XFillRectangle(d,win[0],gcb,FILLHISx,FILLHISy,70,26);
	       PrintMessage(1);
	       goto Player2;
	     } else {
	       phase2 = SORRY;
	       PrintMessage(1);
	       PrintMessage2(4);
	     }
	   }
	 } else {
	   if (AskNage(2) == TRUE) {
	     signal(SIGALRM, SIG_IGN);
	     Win(4);
	   }
	 }
       }
       /* get Koma if (phase == PICK) */
       if (phase == PICK){
         x0 = XtoB(event2.xbutton.x);
         y0 = YtoB(event2.xbutton.y);
	 m = BtoM(event2.xbutton.x,event2.xbutton.y);
         if (CheckInM2(event2.xbutton.x,event2.xbutton.y) == TRUE){
	   if (koma2 == FIRST) {
	     WindowBorderErase(koma);
	     koma2 = SORRY;
	   }
	   PrintMessage2(0);
	   koma = Mochigoma2W[BtoM(event2.xbutton.x,event2.xbutton.y)];
           WindowPick(koma);
           phase = MPUT;
         } else {
           x0 = 8 - x0;
           y0 = 8 - y0;
           if (CheckInB(x0,y0) && CheckFriend2(x0,y0)){
	     if (koma2 == FIRST) {
	       WindowBorderErase(koma);
	       koma2 = SORRY;
	     }
	     PrintMessage2(0);
             koma = BoardW[y0][x0];
             WindowPick(koma);
             phase = PUT;
           }
           break;
         }
       }
    /* put Koma if (phase != PUT) */
       else if (phase == PUT){
	 x = XtoB(event2.xbutton.x);
	 y = YtoB(event2.xbutton.y);
	 if (CheckInB(x,y) && (Button3 != event2.xbutton.button)) {
	   x = 8 - x;
	   y = 8 - y;
	   if ((CheckFriend2(x,y) == FALSE) &&
	       CheckMovePossible2(x0,y0,x,y)) {
	     SaveLastState(x0,y0,x,y,FALSE);
	     i = koma;
	     WindowBorderErase(koma);
	     MoveKoma2(x0,y0,x,y);
	     koma = i;
             WindowPick(koma);
	     signal(SIGALRM, SIG_IGN);
	     PrintMessage(0);
	     PrintMessage2(1);
	     phase2 = FIRST;
	     goto Player1;
	   }
	 }
         phase = PICK;
	 phase2 = SORRY;
         PrintMessage2(4);
         WindowBorderErase(koma);
         break;
       }
    /* put Mochigoma (phase == MPUT) */
       else {
	 x = XtoB(event2.xbutton.x);
	 y = YtoB(event2.xbutton.y);
	 if (CheckInB(x,y) && (Button3 != event2.xbutton.button)) {
	   x = 8 - x;
	   y = 8 - y;
	   if ((Board[y][x] == 0) && (NiFU2(m,x,y) == FALSE) &&
	      (Uchifuzume(2,m,x,y) == FALSE)) {
	     SaveLastState(x0,y0,x,y,TRUE);
	     i = koma;
	     WindowBorderErase(koma);
	     MoveMochigoma2(m,x,y);
	     koma = i;
             WindowPick(koma);
	     signal(SIGALRM, SIG_IGN);
	     PrintMessage(0);
	     PrintMessage2(1);
	     phase2 = FIRST;
	     goto Player1;
	   }
	 }
         phase = PICK;
	 phase2 = SORRY;
         PrintMessage2(4);
	 WindowBorderErase(koma);
         break;
       }
   }
 }   
}

Win(n)
int n;
{
  int i,count=5;
  signal(SIGALRM, SIG_IGN);
  unlink("backup.x2shogi");
  if (BELL) 
    if (n == 1 || n == 3 || n == 5 || n == 8) XBell(d2, 100); 
    else XBell(d, 100);
  alarm(10);
  switch(n){
    case 1:
      PrintMessage(2);
      PrintMessage2(3);
      break;
    case 2:
      PrintMessage(3);
      PrintMessage2(2);
      break;
    case 3:
      PrintMessage(10);
      PrintMessage2(11);
      break;
    case 4:
      PrintMessage(11);
      PrintMessage2(10);
      break;
    case 5:
      PrintMessage(12);
      PrintMessage2(13);
      count = 16;
      break;
    case 6:
      PrintMessage(13);
      PrintMessage2(12);
      count = 16;
      break;
    case 7:
      PrintMessage(15);
      PrintMessage2(16);
      break;
    case 8:
      PrintMessage(16);
      PrintMessage2(15);
      break;
    }
  i = 0;
  while (i++ != count) {
    while (XEventsQueued(d, QueuedAfterFlush) != 0) {
      XNextEvent(d, &event);
      switch(event.type) {
      case Expose:
        DrawLine();
        WindowPick(koma);
        if (n < 3) {
          ExposePrintMessage(n+1);
          ExposePrintTime1();
          break;
        } else if (n < 5) {
          ExposePrintMessage(n+7);
          ExposePrintTime1();
          break;
        } else if (n < 7) {
          ExposePrintMessage(n+7);
          ExposePrintTime1();
          break;
        } else {
          ExposePrintMessage(n+8);
          ExposePrintTime1();
          break;
        }
      }
    } 
    while (XEventsQueued(d2, QueuedAfterFlush) != 0) {
      XNextEvent(d2, &event2);
      switch(event2.type) {
      case Expose:
        DrawLine2();
        WindowPick(koma);
        if (n < 3) {
          ExposePrintMessage2(4-n);
          ExposePrintTime2();
          break;
        } else if (n < 5) {
          ExposePrintMessage2(14-n);
          ExposePrintTime2();
          break;
        } else if (n < 7) {
          ExposePrintMessage2(18-n);
          ExposePrintTime2();
          break;
        } else {  
          ExposePrintMessage2(23-n);
          ExposePrintTime2();
          break;
        }
      }
    }
    sleep(1);
  }
  if (n == 2 || n == 3 || n == 6 || n == 8) printf("You won!\n");
  else printf("You lost.\n");
  exit(1);
}

